#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> ii;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<ii> vii;
#define ff first
#define ss second
#define D(a) cerr << ">> " << #a << " >" << a << "<" << endl
#define MP make_pair
#define PB push_back
#define FOR(i, a, b) for (int i = (a); i < (b); ++i)
#define FORE(i, a, b) for (int i = (a); i <= (b); ++i)
#define FORDE(i, a, b) for (int i = (a); i >= (b); --i)
#define R1(a) scanf("%d", &a)
#define R2(a, b) scanf("%d%d", &a, &b)
#define R3(a, b, c) scanf("%d%d%d", &a, &b, &c)
#define DRI(a) int a;scanf("%d", &a)
#define DRII(a, b) int a,b;scanf("%d%d", &a, &b)
#define DRIII(a, b, c) int a,b,c;scanf("%d%d%d", &a, &b, &c)
#define MM(co, cim) memset((co), (cim), sizeof((co)))

struct VectorD {
  double x, y;
  VectorD() {}
  VectorD(double a, double b) : x(a) , y(b) {}
  
  VectorD operator-(const VectorD& v) const {return VectorD(x-v.x,y-v.y);}
  VectorD operator+(const VectorD& v) const {return VectorD(x+v.x,y+v.y);}
  
  double size() const {return sqrt(x*x+y*y);}
};


struct Vector {
  ll x, y;
  Vector() {}
  Vector(ll a, ll b) : x(a) , y(b) {}

  Vector operator-(const Vector& v) const {return Vector(x-v.x,y-v.y);}
  VectorD operator*(double d) const {return VectorD(d*x,d*y);}
  double size() const {return sqrt((double)(x*x+y*y));}
};

ll cross_product(const Vector& v1, const Vector& v2) {
  return v1.y*v2.x-v1.x*v2.y;
}

double cross_product(const VectorD& v1, const VectorD& v2) {
  return v1.x*v2.y - v1.y * v2.x;
}

VectorD copy(const Vector& vv) {
  return VectorD(vv.x,vv.y);
}

const int INF = 1e9 + 7;

int N;
Vector A,B;
Vector v;
Vector blockP[107][7];
Vector mainP[7];
vector<double> positions;

double getX(double x1, double y1, double x2, double y2, double x3, double y3, double x4, double y4) {
  return ((x1 * y2 - y1 * x2) * (x3 - x4) - (x1 - x2) * (x3 * y4 - y3 * x4)) / ((x1 - x2) * (y3 - y4) - (y1 - y2) * (x3 - x4));
}
double getY(double x1, double y1, double x2, double y2, double x3, double y3, double x4, double y4) {
  return ((x1 * y2 - y1 * x2) * (y3 - y4) - (y1 - y2) * (x3 * y4 - y3 * x4)) / ((x1 - x2) * (y3 - y4) - (y1 - y2) * (x3 - x4));
}

double getT(Vector p1, Vector p2, Vector p3, Vector p4) {
  double xx = getX(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, p4.x, p4.y);
  double yy = getY(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, p4.x, p4.y);
  D(xx);
  D(yy);
  VectorD vvv = VectorD(xx,yy);
  return (vvv-copy(A)).size()/copy(v).size();
}

bool isVisible(VectorD point) {
    FOR(i,0,N-1) {
      bool allPos = true;
      bool allNeg = true;
      FOR(j,0,4) FOR(k,0,4) {
        VectorD u = copy(blockP[i][j])-point;
        VectorD w = copy(mainP[k])-point;
        double x = cross_product(u,w);
        if(x < 0.0) allPos = false;
        if(x > 0.0) allNeg = false;
      }
      if(!allPos && !allNeg) return false;
    }
    return true;
}

int main ()
{
  while(true) {
    R1(N);
    if(N == 0) break;
    positions.clear();
    ll x,y;
    cin >> x >> y;
    A = Vector(x,y);
    cin >> x >> y;
    B = Vector(x,y);
    v = B-A;
    FOR(j,0,4) {
      cin >> x >> y;
      mainP[j] = Vector(x,y);
    }
    FOR(i,0,N-1) {
      FOR(j,0,4) {
        cin >> x >> y;
        blockP[i][j] = Vector(x,y);
      }
    }
    
    double res = 0;
    positions.PB(0.0);
    positions.PB(1.0);
    FOR(i,0,N-1) {
      D(i);
      FOR(j,0,4) FOR(k,0,4) {
        D(j);
        D(k);
        Vector u = blockP[i][j]-mainP[k];
        cout << u.x << " " << u.y << endl;
        Vector vv = (mainP[k]-A);
        cout << vv.x << " " << vv.y << endl;
        cout << A.x << " " << A.y << endl;
        cout << B.x << " " << B.y << endl;
        cout << v.x << " " << v.y << endl;
        if(cross_product(u,v) == 0LL) continue;
        //double t = (double)cross_product(vv,u) / (double)cross_product(v,u);
        double t = getT(mainP[k],blockP[i][j],A,B);
        double tt = (double)cross_product(vv,v) / (double)cross_product(u,v);
        D(t);
        D(tt);
        if(t < 0 || t > 1) continue;
        D("go");
        positions.PB(t);
      }
    }
    
    sort(positions.begin(),positions.end());

    FOR(i,0,positions.size()) cout << " " << positions[i] << endl;

    FOR(i,0,positions.size()) {
      VectorD point = copy(A) + Vector(v)*((positions[i]+positions[i+1])/2.0);
      bool vis = isVisible(point);
      if(vis) res += v.size() * (positions[i]-positions[i-1]);
    }
    
    printf("%f\n", res);
    
  }
  return 0;
}














